## $Id: browser.py 7525 2012-01-27 18:24:31Z henrik $
##
## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
import grok
from zope.formlib.textwidgets import BytesDisplayWidget
from waeup.sirp.widgets.datewidget import (
    FriendlyDateWidget, FriendlyDateDisplayWidget
    )
from waeup.custom.students.interfaces import (
    IStudent, IStudentPersonal, IStudentClearance, IStudentClearanceEdit
    )
from waeup.sirp.students.browser import (
    StudentPersonalDisplayFormPage, StudentPersonalManageFormPage,
    StudentClearanceManageFormPage, StudentClearanceEditFormPage,
    StudentClearanceDisplayFormPage
    )

class StudentPersonalDisplayFormPage(StudentPersonalDisplayFormPage):
    """ Page to display student personal data
    """
    grok.context(IStudent)
    form_fields = grok.AutoFields(IStudentPersonal)
    form_fields['perm_address'].custom_widget = BytesDisplayWidget

class StudentPersonalManageFormPage(StudentPersonalManageFormPage):
    """ Page to edit student clearance data
    """
    grok.context(IStudent)
    form_fields = grok.AutoFields(IStudentPersonal)

class StudentClearanceDisplayFormPage(StudentClearanceDisplayFormPage):
    """ Page to display student clearance data
    """
    grok.context(IStudent)
    form_fields = grok.AutoFields(IStudentClearance).omit('clearance_locked')
    form_fields['date_of_birth'].custom_widget = FriendlyDateDisplayWidget('le')

class StudentClearanceManageFormPage(StudentClearanceManageFormPage):
    """ Page to edit student clearance data
    """
    grok.context(IStudent)
    form_fields = grok.AutoFields(IStudentClearance)
    form_fields['date_of_birth'].custom_widget = FriendlyDateWidget('le-year')

class StudentClearanceEditFormPage(StudentClearanceEditFormPage):
    """ View to edit student clearance data by student
    """
    grok.context(IStudent)
    form_fields = grok.AutoFields(
        IStudentClearanceEdit).omit('clearance_locked')
    form_fields['date_of_birth'].custom_widget = FriendlyDateWidget('le-year')


